%{
	int	line_nr=1;
	int	yylval;
%}

Eol			\n
Blank			[ \t]
Decimal			[1-9][0-9]*
Octal			0[0-7]*
Hex			0[xX][0-9a-fA-F]+
Literal			[a-zA-Z][a-zA-Z_0-9]*
Keycode			[kK][eE][yY][cC][oO][dD][eE]
Equals			=
Comment			#|!
%%
{Eol}			{line_nr++;return(EOL);}
{Blank}+		; /* do nothing */
{Comment}.*/{Eol}	; /* do nothing */
{Keycode}		{return(KEYCODE);} /* this must be before Literal */
{Decimal}|{Octal}|{Hex}	{yylval=strtol(yytext,NULL,0);return(NUMBER);}
{Literal}		{yylval=ksymtocode(yytext);return(LITERAL);}
{Equals}		{return(EQUALS);} 
%%
#include "ksyms.h"
#include <linux/keyboard.h>

int ksymtocode(char *s)
{
	int i;
	int j;

	for (i = 0; i < syms_size; i++)
		for (j = 0; j < syms[i].size; j++)
			if (!strcmp(s,syms[i].table[j]))
				return K(i, j);
	fprintf(stderr, "unknown keysym '%s'\n", s);
	return -1;
}
